![OhMyForm](public/logo.png)

# OhMyForm

Upstream: https://github.com/ohmyform/ohmyform

[Demo](https://demo.ohmyform.org/) Username and password are just `demo`.  We will reset the demo instance at least once for every new release and possibly more often so don't rely on it for sending actual forms expect no notice for resets.

> An *open source alternative to TypeForm* that can create stunning mobile-ready forms, surveys and questionnaires.

## Table of Contents  

<!-- TOC depthFrom:1 depthTo:6 withLinks:1 updateOnSave:1 orderedList:0 -->

- [OhMyForm](#ohmyform-091)
	- [Table of Contents](#table-of-contents)
	- [Features](#features)
		- [On the Roadmap](#on-the-roadmap)
	- [How to Contribute](#how-to-contribute)
	- [Quickstart](#quickstart)
	- [Where to get help](#where-to-get-help)

<!-- /TOC -->

## Features

	- Multi-Language Support
	- 11 possible question types
	- Editable start and end pages
	- Export Submissions to XLS, JSON or CSV
	- Native Analytics and Google Analytics Support
	- Embeddable Forms
	- Forms as a Service API
    - Customizable Notifications on Form Submission
	- Web Hooks on Form Submission
	- Deployable with Heroku and DockerHub
    - PostgreSQL and sqlite

<!-- TODO: Determine roadmap for OhMyForm if it is to be different from OhMyForm's roadmap. -->
<!-- ### On the Roadmap (Tentative pending [refactor](https://github.com/ohmyform/ohmyform/pull/1)) -->

### On the Roadmap
	- Custom Subdomains for each User
	- Implement encryption for all form data
	- Add Typeform API integration
	- Add plugin/3rd party integration support (aka Slack)
	- Create wiki for easy installation and setup
	- Add Stripe/Payment Form field
	- Add Custom Background and Dropdown Field Images
	- Add File Upload Form Field

<!-- TODO: add a CONTRIBUTING.md. -->
## How to Contribute

Please checkout our [contributing guide](CONTRIBUTING.md) on ways to contribute to OhMyForm.

## Quickstart

Follow documentation hosted on [OhMyForm.com](http://ohmyform.com/docs/install/) it will be the main and hopefully only location to obtain the up to date documentation.

If you pull the repository do not forget to execute: `git submodule update --init`

### Some technical Insights

[API](https://github.com/ohmyform/api/tree/master/doc)

[UI](https://github.com/ohmyform/ui/tree/master/doc)

## Where to get help

[![Discord](https://img.shields.io/discord/595773457862492190.svg?label=Discord%20Chat)](https://discord.gg/Y2TTePM)
